#!/usr/bin/perl -w

use Geo::E00;

# We parse it twice - first to get rank data,
# later to get everything else

open F, $ARGV[0] or die "can't open file";
while (<F> !~ /^RANK/) {}
while (1)
{
    last if <F> =~ /COUNTRY4E.BND/;
    <F> =~ /(\S+)/;
    push @rank, $1;
}

my $e = new Geo::E00;
$e->open($ARGV[0]) or die "can't open file";
my $edata = $e->parse;

for (@{$edata->{arc}}) {
    my $id = $_->{'cov-num'};
    my $outline;
    my @xs;
    my @ys;

    for (@{$_->{'coord'}})
    {
	my $x = $_->{'x'}+0.0;
	my $y = $_->{'y'}+0.0;
	push @xs, $x;
	push @ys, $y;
	$outline .= " $x,$y";
    }
    my $minx = $xs[0];
    my $maxx = $xs[0];
    my $miny = $ys[0];
    my $maxy = $ys[0];
    for my $i(1..$#xs)
    {
	$minx = $xs[$i] if $xs[$i] < $minx;
	$maxx = $xs[$i] if $xs[$i] > $maxx;
	$miny = $ys[$i] if $ys[$i] < $miny;
	$maxy = $ys[$i] if $ys[$i] > $maxy;	
    }
    print $rank[$id-1], " $minx $maxx $miny $maxy$outline\n";
}
