#!/usr/bin/perl -w

srand 1234;

use Geo::E00;
use Digest::MD5 qw{md5_hex};

my @lab;
open LAB, "data/lab";
for(<LAB>)
{
    /(\d+) (.*)/;
    $lab[$1]=$2;
}
close LAB;

my $e = new Geo::E00;
$e->open("data/wdbtemp4.e00") or die "can't open file";
my $edata = $e->parse;

my %pn;

for (@{$edata->{arc}}) {
    $left  = $lab[$_->{'poly-left'}] || "?";
    $right = $lab[$_->{'poly-right'}] || "?";
#    if ($left eq "?")
#    {
#	$pn{$right} ||= {} unless $right eq "?";
#	next;
#    }
#    $pn{$left} ||= {};
#    next if ($right eq "?");
    $pn{$left}{$right} = 1;
    $pn{$right}{$left} = 1;
}

%colors = ();

sub recursive_colorization
{
    my ($lev,$cntcolors,$alr) = @_;

    my %alln_layers2= %$alr;
    my %alln_layers = %alln_layers2;
    my %this_layer  = ();
    my %next_layer  = ();

    for my $poly(keys %alln_layers)
    {
	if ((scalar keys %{$alln_layers{$poly}}) < $cntcolors)
	{
	    $this_layer{$poly} = 1;
	    delete $alln_layers{$poly};
	}
    }
    for my $poly(keys %alln_layers)
    {
	for my $p2 (keys %{$alln_layers{$poly}})
	{
	    $next_layer{$poly}{$p2} = 1 unless $this_layer{$p2};
	}
    }
    unless ((scalar keys %next_layer) == 0)
    {
	recursive_colorization($lev+1,$cntcolors,\%next_layer);
    }

    for my $poly(keys %this_layer)
    {
	my @cavail = (0..$cntcolors-1);
	my @n = keys %{$alln_layers2{$poly}};
	for my $np (@n)
	{
	    my $c = $colors{$np};
	    $cavail[$c] = undef if defined $c;
	}
	my @pcolors;
	for my $cn (0..$#cavail)
	{
	    push @pcolors, $cn if (defined $cavail[$cn])
	}
	$colors{$poly} = $pcolors[rand @pcolors];
    }
}

recursive_colorization(0, 8, \%pn);

for $poly(keys %colors)
{
    my $m = $colors{$poly};
    if ($m == 0) {
	# cyan
	$r = rand 64;
	$g = 160 + rand 64;
	$b = 160 + rand 64;
    } elsif ($m == 1) {
	# green
	$r = 64  + rand 64;
	$g = 160 + rand 64;
	$b = 64  + rand 64;
    } elsif ($m == 2) {
	# yellow-green
	$r = 128 + rand 32;
	$g = 192 + rand 64;
	$b = rand 32;
    } elsif ($m == 3) {
	# greenish-blue
	$r = rand 32;
	$g =  64 + rand 64;
	$b = 128 + rand 64;
    } elsif ($m == 4) {
	# yellow
	$r = 128 + rand 64;
	$g =  96 + rand 64;
	$b = rand 32;
    } elsif ($m == 5) {
	# orange
	$r = 128 + rand 64;
	$g = 64  + rand 64;
	$b = rand 64;
    } elsif ($m == 6) {
	# magenta
	$r = 160 + rand 64;
	$g = 64  + rand 64;
	$b = 160 + rand 64;
    } elsif ($m == 7) {
	# gray
	$r = 96 + rand 64;
	$g = $r - 16 + rand 32;
	$b = $r - 16 + rand 32;
    }
    $colors{$poly} = sprintf "#%02X%02X%02X", $r, $g, $b;
}

open LAB, "data/lab";
for(<LAB>)
{
    /(\d+) (.*)/;
    if ($2 eq '?') {
	print "$1 #000060\n"
    } else {
	$color = $colors{$2};
#	print STDERR "$1\n" unless $color;
	print "$1 $color\n"
    }
}
close LAB;
