#!/usr/bin/perl -w

use Geo::E00;
use Digest::MD5 qw{md5_hex};

my @lab;
open LAB, "data/lab";
for(<LAB>)
{
    /(\d+) (.*)/;
    $lab[$1]=$2;
}
close LAB;

my $e = new Geo::E00;
$e->open("data/wdbtemp4.e00") or die "can't open file";
my $edata = $e->parse;

my %pn;

for (@{$edata->{arc}}) {
    $left  = $lab[$_->{'poly-left'}] || "?";
    $right = $lab[$_->{'poly-right'}] || "?";
    $pn{$left}{$right} = 1;
    $pn{$right}{$left} = 1;
}

for my $poly(sort keys %pn)
{
    my @n = sort keys %{$pn{$poly}};
    print $poly, ": ", join (",", @n), "\n"
}
