#!/usr/bin/ruby

def print_riv(riv,rank)
    return unless riv
    xs = riv.map{|x,y| x}
    ys = riv.map{|x,y| y}
    outline = riv.map{|x,y| "#{x},#{y}"}.join " "
    print "#{rank} #{xs.min} #{xs.max} #{ys.min} #{ys.max} #{outline}\n"
end

lastriv = nil
rank = 1
STDIN.each {|line|
    if line =~ /segment \d+  rank (\d+)  points \d+/
	print_riv(lastriv,rank)
        rank = $1.to_i
        lastriv = []
    elsif line =~ /\t(-?\d+\.\d+) (-?\d+\.\d+)/
        x, y = $2.to_f, $1.to_f
        lastriv.push [x,y]
    else
        p line
        raise "River data parse error"
    end
}
print_riv(lastriv,rank)
